#define _GNU_SOURCE
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <cstring>
#include <dirent.h>
#include <unistd.h>
#include <errno.h>
#include <vector>
#include <string>
using namespace std;

int check_mail(const char* fname)
{
 FILE *f = fopen(fname,"r");
 if (!f) {
  cout << "Nelze otevrit " << fname << ": " << strerror(errno) << "\n";
  return 0;
 }
 int nmesg = 0;
 char buf[512];
 while (fgets(buf,512,f)) {
  if (strncmp(buf,"From ",5) == 0) {
   int len = strlen(buf);
   int i;
   for (i=5; i<len; i++) {
    if (buf[i] == ' ') {
     break;
    }
   }
   while (buf[++i] == ' ');
   if (i != 5 && i != len) {
    char *cas_str = buf+i;
    if (cas_str[strlen(cas_str)-1] == '\n')
     cas_str[strlen(cas_str)-1] = 0;
    struct tm cas;
    memset(&cas,0,sizeof(cas));
    if (strptime(cas_str,"%a %b %e %T %Y",&cas)) {
     nmesg++;
     while (fgets(buf,512,f)) {
      if (strcmp(buf,"\n") == 0) {
       break;
      }
      if (strncasecmp(buf,"Status: ",8) == 0) {
       i = 7;
       while (buf[++i] == ' ');
       char *status = buf+i;
       if (status[strlen(status)-1] == '\n')
	status[strlen(status)-1] = 0;
       len = strlen(status);
       for (i=0;i<len;i++) {
	if ((status[i] | 32) == 'r') {
	 nmesg--;
	 break;
	}
       }
      }
     }
    }
   }
  }
 }
 return nmesg;
}

int porovnej(const void *a, const void *b)
{
 return strcmp(((string*)a)->c_str(),((string*)b)->c_str());
}

int main(int argc, char *argv[])
{
 int pocet_celkem = 0;
 DIR* dp;
 dirent* ep;
 vector<string> mbox;
 char *maildir = 0;
 {
  const char* home;
  if (!(home = getenv("HOME"))) {
   cerr << "Nemas home???\n";
   return -1;
  }
  maildir = (char*) malloc(strlen(home) + 10);
  if (!maildir) {
   cerr << "Chyba malloc\n";
   return -1;
  }
  strcpy(maildir,home);
  strcat(maildir,"/Mail");
 }
 dp = opendir(maildir);
 if (!dp) {
  cout << "Nenasel jsem ~/Mail !!!\n";
 } else {
  while ((ep = readdir(dp))) {
   if (ep->d_type & DT_REG) {
    char *fname = (char*) malloc(strlen(maildir) + _D_EXACT_NAMLEN(ep) + 2);
    if (!fname) {
     cerr << "Chyba malloc\n";
     if (maildir) free(maildir);
     return -1;
    }
    strcpy(fname,maildir);
    strcat(fname,"/");
    strcat(fname,ep->d_name);
    mbox.push_back(fname);
    if (fname) free(fname);
   }
  }
  closedir(dp);
 }
 if (maildir) free(maildir);
 char *spool;
 if ((spool = getenv("MAIL"))) {
  mbox.push_back(spool);
 }
 qsort(mbox.begin()
#if __GNUC__ >= 3
   .base()
#endif
   ,mbox.size(),sizeof(string),&porovnej);

 for (vector<string>::iterator i = mbox.begin(); i != mbox.end(); i++) {
  int pocet = check_mail(i->c_str());
  if (pocet) {
   pocet_celkem += pocet;
   cout << "Mas ";
   printf("%4i",pocet);
   cout << " " << ({
    char* ret;
    if (pocet == 1) {
     ret = "   novy mail";
    } else if (pocet>1 && pocet<5) {
     ret = "  nove maily";
    } else {
     ret = "novych mailu";
    }
    ret;
   }) << " v " << *i << "\n";
  }
 }
 
 if (pocet_celkem) {
  cout << " --\n";
  cout << "Mas celkem " << pocet_celkem << " " << ({
   char* ret;
   if (pocet_celkem == 1) {
    ret = "novy mail";
   } else if (pocet_celkem>1 && pocet_celkem<5) {
    ret = "nove maily";
   } else {
    ret = "novych mailu";
   }
   ret;
  }) << ".\n";
 }
}
